#include	<stdio.h>

#include	<yz/window.h>
#include	<yzuitk/menu.h>
#include	<yzuitk/button.h>
#include	<yzuitk/editline.h>
#include	<yzuitk/scrollbar.h>

void	draw_scrollable_stuff(void	*data, int	x1, int	y1, int	x2, int	y2)
{
	yzPenColor(65535, 65535, 65535);
	yzRect(x1, y1, x2, y2);
	yzPenColor(0, 0, 0);
	yzLine(20, 50, 100, 200);
	yzFillCircle(40, 340, 30);
	yzPenColor(0, 40000, 0);
	yzFillCircle(70, 250, 50);
	yzPenColor(0, 0, 0);
	yzText(10, 50, "Hello");
	yzText(15, 100, "Moo");
	yzText(20, 150, "Said");
	yzText(15, 200, "... the");
	yzText(30, 300, "COW!");
	yzText(10, 350, "Muahahahaha");
}

void	event_scrollable_stuff(void	*data, event_t	ev)
{
	switch(ev.type)
	{
		case	YZ_MOUSE_DRAG:
			yzPenColor(0, 0, 0);
			yzLine(ev.x, ev.y, ev.x2, ev.y2);
			break;
	}
}

main()
{
	window_t		*w;
	event_t			ev;
	popup_menu_t	*pop;
	editline_t		*name;
	button_t		*quit;
	scrollbar_t		*scroll;
	scrollarea_t	*scra;

	w = yzNewWindow("Menu", 176, 275);
	yzSelectWindow(w);
	//yzClear();

	pop = yzAddPopupMenu("Test Menu", 0, 0, 80, 25, 1,
			"Fishes", "Cattle", "Cowboy Neil",
			"X the Unknown", "Fishes", 0);
	name = yzAddEditline("Hello", 0, 25, 80, 25, 1, YZ_EDITLINE_RETURN | YZ_EDITLINE_ENTER);
	quit = yzAddButton("Quit", 0, 50, 80, 25, 1);
	scroll = yzAddScrollBar(161, 0, 15, 275, 1);
	yzSetScrollBarMax(scroll, 500);
	yzSetScrollBarPageSize(scroll, 205);
	yzSetScrollBarPosition(scroll, 0);
	scra = yzAddScrollArea(80, 70, 81, 205, draw_scrollable_stuff, event_scrollable_stuff, 0);
	yzSetScrollBarArea(scroll, scra);

	do
	{
		ev = yzGetEvent(80);
		yzFlashCaret();
		switch(ev.type)
		{
			case	YZ_UI_EVENT:
				if(ev.ui_element == pop)
					printf("Selected item was: %s\n",
						yzPopupGetItemName(pop, pop->lastSel));
				break;
			case	YZ_KEY_DOWN:
				if(ev.key == 3 || ev.key=='\n')
				{
					printf("Your name is: %s\n",
						yzGetEditlineText(name));
				}
				break;
		}
	} while(ev.type != YZ_BUTTON_HIT);
}
